﻿//начало текста модуля

///////////////////////////////////////////////////
//Служебные функции и процедуры
///////////////////////////////////////////////////

&НаКлиенте
// контекст фреймворка Vanessa-Behavior
Перем Ванесса;
 
&НаКлиенте
// Структура, в которой хранится состояние сценария между выполнением шагов. Очищается перед выполнением каждого сценария.
Перем Контекст Экспорт;
 
&НаКлиенте
// Структура, в которой можно хранить служебные данные между запусками сценариев. Существует, пока открыта форма Vanessa-Behavior.
Перем КонтекстСохраняемый Экспорт;

&НаКлиенте
// Функция экспортирует список шагов, которые реализованы в данной внешней обработке.
Функция ПолучитьСписокТестов(КонтекстФреймворкаBDD) Экспорт
	Ванесса = КонтекстФреймворкаBDD;
	
	ВсеТесты = Новый Массив;

	//описание параметров
	//Ванесса.ДобавитьШагВМассивТестов(ВсеТесты,Снипет,ИмяПроцедуры,ПредставлениеТеста,ОписаниеШага,ТипШага,Транзакция,Параметр);

	Ванесса.ДобавитьШагВМассивТестов(ВсеТесты,"ЯСохраняюСлужебнуюEpfДляПроверкиРаботыКешВКаталогTemplates(Парам01)","ЯСохраняюСлужебнуюEpfДляПроверкиРаботыКешВКаталогTemplates","Дано     Я сохраняю служебную epf 1 для проверки работы кеш в каталог Templates","","");

	Возврат ВсеТесты;
КонецФункции
	
&НаСервере
// Служебная функция.
Функция ПолучитьМакетСервер(ИмяМакета)
	ОбъектСервер = РеквизитФормыВЗначение("Объект");
	Возврат ОбъектСервер.ПолучитьМакет(ИмяМакета);
КонецФункции
	
&НаКлиенте
// Служебная функция для подключения библиотеки создания fixtures.
Функция ПолучитьМакетОбработки(ИмяМакета) Экспорт
	Возврат ПолучитьМакетСервер(ИмяМакета);
КонецФункции



///////////////////////////////////////////////////
//Работа со сценариями
///////////////////////////////////////////////////

&НаКлиенте
// Процедура выполняется перед началом каждого сценария
Процедура ПередНачаломСценария() Экспорт
	ИмяEpf = Ванесса.Объект.КаталогИнструментов + "\features\Support\Templates\step_definitions\ФичаДляПроверкиРаботыКеш.epf";
	Контекст.Вставить("ИмяEpf",ИмяEpf);
	Ванесса.УдалитьФайлыКомандаСистемы(Контекст.ИмяEpf);
КонецПроцедуры

&НаКлиенте
// Процедура выполняется перед окончанием каждого сценария
Процедура ПередОкончаниемСценария() Экспорт
	Ванесса.УдалитьФайлыКомандаСистемы(Контекст.ИмяEpf);
КонецПроцедуры



///////////////////////////////////////////////////
//Реализация шагов
///////////////////////////////////////////////////

&НаКлиенте
//Дано     Я сохраняю служебную epf 1 для проверки работы кеш в каталог Templates
//@ЯСохраняюСлужебнуюEpfДляПроверкиРаботыКешВКаталогTemplates(Парам01)
Процедура ЯСохраняюСлужебнуюEpfДляПроверкиРаботыКешВКаталогTemplates(Парам01) Экспорт
	Ванесса.УдалитьФайлыКомандаСистемы(Контекст.ИмяEpf);
	Макет = ПолучитьМакетСервер("Макет"+Парам01);
	Макет.Записать(Контекст.ИмяEpf);
КонецПроцедуры
