﻿//начало текста модуля

#Область Служебные_функции_и_процедуры

&НаКлиенте
// контекст фреймворка Vanessa-Behavior
Перем Ванесса;
 
&НаКлиенте
// Структура, в которой хранится состояние сценария между выполнением шагов. Очищается перед выполнением каждого сценария.
Перем Контекст Экспорт;
 
&НаКлиенте
// Структура, в которой можно хранить служебные данные между запусками сценариев. Существует, пока открыта форма Vanessa-Behavior.
Перем КонтекстСохраняемый Экспорт;

&НаКлиенте
// Функция экспортирует список шагов, которые реализованы в данной внешней обработке.
Функция ПолучитьСписокТестов(КонтекстФреймворкаBDD) Экспорт
	Ванесса = КонтекстФреймворкаBDD;
	
	ВсеТесты = Новый Массив;

	//описание параметров
	//Ванесса.ДобавитьШагВМассивТестов(ВсеТесты,Снипет,ИмяПроцедуры,ПредставлениеТеста,Транзакция,Параметр);

	Ванесса.ДобавитьШагВМассивТестов(ВсеТесты,"ВПолеЯВвожуТекстФичи(Парам01,Парам02)","ВПолеЯВвожуТекстФичи","И     в поле ""СгенерированныйСценарий"" я ввожу текст фичи ""ФичаДляПроверкиРаботСекцииКонтекст_Тег_tree""");
	Ванесса.ДобавитьШагВМассивТестов(ВсеТесты,"ВПолеЯВвожуЗаписьДействийПользователя(Парам01)","ВПолеЯВвожуЗаписьДействийПользователя","И     в поле ""СгенерированныйXML"" я ввожу запись действий пользователя");
	Ванесса.ДобавитьШагВМассивТестов(ВсеТесты,"ВПолеНаходитсяТекстИзМакета(Парам01,Парам02)","ВПолеНаходитсяТекстИзМакета","Тогда в поле ""СгенерированныйСценарий"" находится текст из макета ""СгенерированныйСценарий""");
	Ванесса.ДобавитьШагВМассивТестов(ВсеТесты,"ЯВыполняюПодготовкуСценарияКВыполнению()","ЯВыполняюПодготовкуСценарияКВыполнению","И     я выполняю подготовку сценария к выполнению");
	Ванесса.ДобавитьШагВМассивТестов(ВсеТесты,"ТаблицаФормыVanessaBehaviorСИменемСталаРавной(Парам01,ТабПарам)","ТаблицаФормыVanessaBehaviorСИменемСталаРавной","И     таблица формы VanessaBehavior с именем ""ДеревоТестов"" стала равной:");

	Возврат ВсеТесты;
КонецФункции
	
&НаСервере
// Служебная функция.
Функция ПолучитьМакетСервер(ИмяМакета)
	ОбъектСервер = РеквизитФормыВЗначение("Объект");
	Возврат ОбъектСервер.ПолучитьМакет(ИмяМакета);
КонецФункции
	
&НаКлиенте
// Служебная функция для подключения библиотеки создания fixtures.
Функция ПолучитьМакетОбработки(ИмяМакета) Экспорт
	Возврат ПолучитьМакетСервер(ИмяМакета);
КонецФункции

#КонецОбласти



#Область Работа_со_сценариями

&НаКлиенте
// Процедура выполняется перед началом каждого сценария
Процедура ПередНачаломСценария() Экспорт
	
КонецПроцедуры

&НаКлиенте
// Процедура выполняется перед окончанием каждого сценария
Процедура ПередОкончаниемСценария() Экспорт
	//безусловное закрытие формы если она осталась
	Попытка
	    ОткрытаяФормаVanessaBehavoir = Контекст.ОткрытаяФормаVanessaBehavoir;
		ОткрытаяФормаVanessaBehavoir.Закрыть();
	Исключение
		
	КонецПопытки;
КонецПроцедуры

#КонецОбласти


///////////////////////////////////////////////////
//Реализация шагов
///////////////////////////////////////////////////

&НаКлиенте
//И     в поле "СгенерированныйСценарий" я ввожу текст фичи "Issue-461-Обработка временной фичи"
//@ВПолеЯВвожуТекстФичи(Парам01,Парам02)
Процедура ВПолеЯВвожуТекстФичи(ИмяПоля,ИмяФичи) Экспорт

	ПутьКФиче = Ванесса.Объект.КаталогИнструментов + "\features\Support\Templates\" + ИмяФичи + ".feature";
	// прочитать файл
	ФичаФайла = Новый ЧтениеТекста(ПутьКФиче, КодировкаТекста.UTF8);
	ТекстФичи = ФичаФайла.Прочитать();

	ОткрытаяФормаVanessaBehavoir                         = Контекст.ОткрытаяФормаVanessaBehavoir;
	ОткрытаяФормаVanessaBehavoir.Объект.СгенерированныйСценарий = ТекстФичи;
	ОткрытаяФормаVanessaBehavoir.ПодготовитьСценарийКВыполнению();
	
КонецПроцедуры

//окончание текста модуля

&НаКлиенте
//И     в поле "СгенерированныйXML" я ввожу запись действий пользователя
//@ВПолеЯВвожуЗаписьДействийПользователя(Парам01)
Процедура ВПолеЯВвожуЗаписьДействийПользователя(Парам01) Экспорт
	
	ТекстЗаписи = ПолучитьМакетСервер("ЗаписьДействийПользователя").ПолучитьТекст();
	
	ОткрытаяФормаVanessaBehavoir                           = Контекст.ОткрытаяФормаVanessaBehavoir;
	ОткрытаяФормаVanessaBehavoir.Объект.СгенерированныйXML = ТекстЗаписи;
	ОткрытаяФормаVanessaBehavoir.ПреобразоватьИсходныйXML();

КонецПроцедуры

&НаКлиенте
//Тогда в поле "СгенерированныйСценарий" находится текст из макета "СгенерированныйСценарий"
//@ВПолеНаходитсяТекстИзМакета(Парам01,Парам02)
Процедура ВПолеНаходитсяТекстИзМакета(Парам01,Парам02) Экспорт
	ТекстСценария = ПолучитьМакетСервер("СгенерированныйСценарий").ПолучитьТекст();
	
	ОткрытаяФормаVanessaBehavoir                    = Контекст.ОткрытаяФормаVanessaBehavoir;
	Если ОткрытаяФормаVanessaBehavoir.Объект.СгенерированныйСценарий <> ТекстСценария Тогда
		Сообщить("ОткрытаяФормаVanessaBehavoir.Объект.СгенерированныйСценарий:");
		Сообщить(ОткрытаяФормаVanessaBehavoir.Объект.СгенерированныйСценарий);
		Сообщить("ТекстСценария:");
		Сообщить(ТекстСценария);
		ВызватьИсключение "Ошибка генерации сценария из действий пользователя";
	КонецЕсли;
	
КонецПроцедуры

&НаКлиенте
//И     я выполняю подготовку сценария к выполнению
//@ЯВыполняюПодготовкуСценарияКВыполнению()
Процедура ЯВыполняюПодготовкуСценарияКВыполнению() Экспорт

	ОткрытаяФормаVanessaBehavoir = Контекст.ОткрытаяФормаVanessaBehavoir;
	ОткрытаяФормаVanessaBehavoir.ПодготовитьСценарийКВыполнению();
	
КонецПроцедуры

&НаКлиенте
Процедура ПреобразоватьТекстДереваВМассив(ЭлементыДерева,МассивСтрокДерева)
	Для Каждого Элем Из ЭлементыДерева Цикл
		МассивСтрокДерева.Добавить(Элем.Имя);
		ПреобразоватьТекстДереваВМассив(Элем.ПолучитьЭлементы(),МассивСтрокДерева);
	КонецЦикла;	
КонецПроцедуры

&НаКлиенте
//И     таблица формы VanessaBehavior с именем "ДеревоТестов" стала равной:
//@ТаблицаФормыVanessaBehaviorСИменемСталаРавной(Парам01,ТабПарам)
Процедура ТаблицаФормыVanessaBehaviorСИменемСталаРавной(Парам01,ТабПарам) Экспорт

	ОткрытаяФормаVanessaBehavoir = Контекст.ОткрытаяФормаVanessaBehavoir;
	
	ЭлементыДерева = ОткрытаяФормаVanessaBehavoir.Объект.ДеревоТестов.ПолучитьЭлементы();
	
	Ванесса.ПроверитьНеРавенство(ЭлементыДерева.Количество(),0,"Должны быть строки в дереве.");
	
	МассивСтрокДерева = Новый Массив;
	ПреобразоватьТекстДереваВМассив(ЭлементыДерева,МассивСтрокДерева);
	
	Для н = 1 По ТабПарам.Количество() - 1  Цикл
		Ванесса.ПроверитьРавенство(МассивСтрокДерева[н-1],ТабПарам[н].Кол1,"Значение в строке №" + н + " <" + МассивСтрокДерева[н-1] + "> не равно ожидаемому значению <" + ТабПарам[н].Кол1 + ">");
	КонецЦикла;
	
КонецПроцедуры
