﻿# language: ru

@IgnoreOnCIMainBuild
@DocumentationBuild
@tree

Функционал: Инструкция по асинхронному выполнению шагов
	Как Разработчик
	Я Хочу чтобы я мог выполнять шаги асинхронно
	Чтобы я мог использовать асинхронные механизмы платформы при программировании шагов
 
Контекст:
	Дано я добавляю в служебные файлы автоинструкции "Support\Instructions\Temp\РаботаСТаймером.feature"
	И    я добавляю в служебные файлы автоинструкции "Support\Instructions\Temp\step_definitions\РаботаСТаймером.epf"
	И    я убедился, что служебные файлы фичи удалены
	
Сценарий: Работа с таймером
		
		
		
	
	Сначала мы напишем простой feature файл, который будет ожидать какого-то события
	
			Когда Я открываю Visual Studio Code
			И я пишу "Функционал: Фича, в которой есть шаг, который длится неопределенное время  "
			И я пишу "Как Разработчик "
			И я пишу "Я хочу чтобы у меня был шаг, который длится неопределенное время "
			И я пишу "Чтобы я мог выполнить тестовый пример "
			И я добавляю пустую строку
			И я пишу "Контекст: "
			И я пишу "	Дано Я запускаю сценарий открытия TestClient или подключаю уже существующий "
			И я пишу 'И я прижимаю активное окно вправо '
			И я перехожу к началу строчки
			И я добавляю пустую строку
			И я пишу 'Сценарий: Долгое проведение документа '
			
	Далее мы напишем шаги, которые создают и проводят документ. И мы заранее не знаем сколько будет проводиться наш документ.
			И я пишу '	Когда В панели разделов я выбираю "Основная" '
			И я пишу '	И     В панели функций я выбираю "Документ1" '
			И я пишу 'И     я нажимаю на кнопку "Создать" '
			И я пишу 'Тогда открылось окно "Документ1 (создание)" '
			И я пишу 'И     я нажимаю на кнопку "Записать" '
			И я пишу 'И     я запоминаю значение поля "Номер" как "НомерДокумента" '
			И видеовставка 'Этот шаг сохранит в переменную Контекст значение поля Номер, т.е. в коде можно будет писать: Контекст.НомерДокумента'
			И я пишу 'И     я нажимаю на кнопку "Провести и закрыть" '
			И я пишу 'И     я ожидаю окончания проведения документа1 '	
			И видеовставка 'В этом шаге мы будем использовать таймер, т.к. мы предполагаем, что документ может проводиться достаточно долго. '
			
			И я сохраняю файл открытый в редакторе как "Support\Instructions\Temp\РаботаСТаймером.feature"
			И я закрываю текстовый редактор
	
			
	Теперь создадим epf по этой фиче		
	
			Когда Я запускаю сеанс TestManager в служебной базе
			И Пауза 5
			И я разворачиваю активное окно на полный экран
			И Я запускаю Vanessa-Behavior интерактивно
			И Я загружаю один feature файл "Support\Instructions\Temp\РаботаСТаймером.feature"
			И Я создаю EPF файл в сеансе служебной базы
			И В каталоге появилась обработка "Support\Instructions\Temp\step_definitions\РаботаСТаймером.epf"
			

	И Затем надо открыть полученную обработку в конфигураторе
	
			Тогда я запускаю конфигуратор служебной базы 
			И Я открываю в конфигураторе созданный файл "Support\Instructions\Temp\step_definitions\РаботаСТаймером.epf"


			
	Далее надо написать код в полученных процедурах
	
			
			И видеовставка 'видеовставка. В модуле была создана только одна процедура, хотя шагов в фиче было больше.'
			И видеовставка 'Это происходит благодаря механизму повторного использования шагов.'
			
			И я перехожу внутрь процедуры "ЯОжидаюОкончанияПроведенияДокумента1"
			И я добавляю строку 'Ванесса.ЗапретитьВыполнениеШагов();'
			И я добавляю строку 'ПодключитьОбработчикОжидания("ОбработчикОжиданияПроведенияДокумента",1);'
			И видеовставка 'Теперь мы остановили выполнение шагов, пока не выполнится нужное нам условие.'
			
			И я перехожу в конец модуля
			
			Напишем обработку таймера
					И я добавляю строку '&НаКлиенте'
					И я добавляю строку 'Процедура ОбработчикОжиданияПроведенияДокумента()'
					И я добавляю строку 'Если ДокументСуществует(Контекст.НомерДокумента,Истина) Тогда'
					И я добавляю строку 'ОтключитьОбработчикОжидания("ОбработчикОжиданияПроведенияДокумента");'
					И я добавляю строку 'Ванесса.ПродолжитьВыполнениеШагов();'
					И я добавляю строку 'КонецЕсли;'
					И я добавляю строку 'КонецПроцедуры'
					
					

			Напишем запрос, проверяющий существование документа		
					И я перехожу в конец модуля
					И я добавляю строку '&НаСервере'
					И я добавляю строку 'Функция ДокументСуществует(Номер,Проведен)'
					И я вызываю конструктор запроса с обработкой результата
					И я перехожу к закладке Таблицы и поля
					И я перехожу к ветке дерева "Документы"
					И я перехожу к ветке дерева "Документ1"
					И я перехожу к строке дерева "Ссылка"
					И я выбираю текущую строку
					И я перехожу к закладке Условия
					И я перехожу к левой части условий запроса
					И я раскрываю ветку дерева
					И я перехожу к строке дерева "Номер"
					И я выбираю текущую строку
					И я перехожу к строке дерева "Проведен"
					И я выбираю текущую строку
					И я нажимаю кнопку ОК конструктора запросов
					И я добавляю строку после текста "ВыборкаДетальныеЗаписи.Следующий()"
					И я добавляю строку 'Возврат Истина;'
					И я добавляю строку после текста "КонецЦикла;"
					И я добавляю строку 'Возврат Ложь;'
					И я добавляю строку 'КонецФункции'
			
			
			И я сохраняю изменения в файле
			И я закрываю конфигуратор служебной базы
			
			

	И теперь мы выполним нашу фичу
	
			И я прижимаю активное окно влево
			И Я нажимаю на кнопку Перезагрузить сценарии
			И Я нажимаю на кнопку Выполнить Сценарии
			И я ожидаю окончания выполнения сценариев в сеансе служебной базы
			И видеовставка 'Спасибо за внимание!'
		
			
	
			