﻿//начало текста модуля

///////////////////////////////////////////////////
//Служебные функции и процедуры
///////////////////////////////////////////////////

&НаКлиенте
// контекст фреймворка Vanessa-Behavior
Перем Ванесса;
 
&НаКлиенте
// Структура, в которой хранится состояние сценария между выполнением шагов. Очищается перед выполнением каждого сценария.
Перем Контекст Экспорт;
 
&НаКлиенте
// Структура, в которой можно хранить служебные данные между запусками сценариев. Существует, пока открыта форма Vanessa-Behavior.
Перем КонтекстСохраняемый Экспорт;

&НаКлиенте
// Служебная функция.
Функция ДобавитьШагВМассивТестов(МассивТестов,Снипет,ИмяПроцедуры,ПредставлениеТеста = Неопределено,Транзакция = Неопределено,Параметр = Неопределено)
	Структура = Новый Структура;
	Структура.Вставить("Снипет",Снипет);
	Структура.Вставить("ИмяПроцедуры",ИмяПроцедуры);
	Структура.Вставить("ИмяПроцедуры",ИмяПроцедуры);
	Структура.Вставить("ПредставлениеТеста",ПредставлениеТеста);
	Структура.Вставить("Транзакция",Транзакция);
	Структура.Вставить("Параметр",Параметр);
	МассивТестов.Добавить(Структура);
КонецФункции

&НаКлиенте
// Функция экспортирует список шагов, которые реализованы в данной внешней обработке.
Функция ПолучитьСписокТестов(КонтекстФреймворкаBDD) Экспорт
	Ванесса = КонтекстФреймворкаBDD;
	
	ВсеТесты = Новый Массив;

	//описание параметров
	//Ванесса.ДобавитьШагВМассивТестов(ВсеТесты,Снипет,ИмяПроцедуры,ПредставлениеТеста,ОписаниеШага,ТипШага,Транзакция,Параметр);

	Ванесса.ДобавитьШагВМассивТестов(ВсеТесты,"ЯВыполняюПростойШагКонтекста()","ЯВыполняюПростойШагКонтекста","Дано я выполняю простой шаг контекста","","");
	Ванесса.ДобавитьШагВМассивТестов(ВсеТесты,"ЯВыполняюВторойПростойШагИ(Парам01,Парам02)","ЯВыполняюВторойПростойШагИ","Когда я выполняю второй простой шаг ""Параметр1"" и ""Параметр2""","","");
	Ванесса.ДобавитьШагВМассивТестов(ВсеТесты,"ЭтотШагДолженБытьПроигнориорованВАвтоинструкции()","ЭтотШагДолженБытьПроигнориорованВАвтоинструкции","И этот шаг должен быть проигнориорован в автоинструкции","","");
	Ванесса.ДобавитьШагВМассивТестов(ВсеТесты,"ЯВыполняюПростойШагВГруппеОдин()","ЯВыполняюПростойШагВГруппеОдин","Когда я выполняю простой шаг в группе один","","");
	Ванесса.ДобавитьШагВМассивТестов(ВсеТесты,"ЯВыполняюПростойШагВГруппеДва()","ЯВыполняюПростойШагВГруппеДва","Когда я выполняю простой шаг в группе два","","");
	Ванесса.ДобавитьШагВМассивТестов(ВсеТесты,"ЯВыполняюПростойШагВГруппеТри()","ЯВыполняюПростойШагВГруппеТри","Когда я выполняю простой шаг в группе три","","");
	Ванесса.ДобавитьШагВМассивТестов(ВсеТесты,"ЯВыполняюПростойШагВГруппеЧетыре()","ЯВыполняюПростойШагВГруппеЧетыре","Когда я выполняю простой шаг в группе четыре","","");
	Ванесса.ДобавитьШагВМассивТестов(ВсеТесты,"ЯВыполняюПростойШагВГруппеПять()","ЯВыполняюПростойШагВГруппеПять","Когда я выполняю простой шаг в группе пять","","");
	Ванесса.ДобавитьШагВМассивТестов(ВсеТесты,"ЯВыполняюПростойШагВГруппеШесть()","ЯВыполняюПростойШагВГруппеШесть","Когда я выполняю простой шаг в группе шесть","","");

	Возврат ВсеТесты;
КонецФункции
	
&НаСервере
// Служебная функция.
Функция ПолучитьМакетСервер(ИмяМакета)
	ОбъектСервер = РеквизитФормыВЗначение("Объект");
	Возврат ОбъектСервер.ПолучитьМакет(ИмяМакета);
КонецФункции
	
&НаКлиенте
// Служебная функция для подключения библиотеки создания fixtures.
Функция ПолучитьМакетОбработки(ИмяМакета) Экспорт
	Возврат ПолучитьМакетСервер(ИмяМакета);
КонецФункции



///////////////////////////////////////////////////
//Работа со сценариями
///////////////////////////////////////////////////

&НаКлиенте
// Процедура выполняется перед началом каждого сценария
Процедура ПередНачаломСценария() Экспорт
	
КонецПроцедуры

&НаКлиенте
// Процедура выполняется перед окончанием каждого сценария
Процедура ПередОкончаниемСценария() Экспорт
	
КонецПроцедуры



///////////////////////////////////////////////////
//Реализация шагов
///////////////////////////////////////////////////

&НаКлиенте
//Дано я выполняю простой шаг контекста
//@ЯВыполняюПростойШагКонтекста()
Процедура ЯВыполняюПростойШагКонтекста() Экспорт
	
КонецПроцедуры

//окончание текста модуля

&НаКлиенте
//Когда я выполняю второй простой шаг "Параметр1" и "Параметр2"
//@ЯВыполняюВторойПростойШагИ(Парам01,Парам02)
Процедура ЯВыполняюВторойПростойШагИ(Парам01,Парам02) Экспорт
КонецПроцедуры

//И этот шаг должен быть проигнориорован в автоинструкции
//@ЭтотШагДолженБытьПроигнориорованВАвтоинструкции()
Процедура ЭтотШагДолженБытьПроигнориорованВАвтоинструкции() Экспорт
КонецПроцедуры

//Когда я выполняю простой шаг в группе один
//@ЯВыполняюПростойШагВГруппеОдин()
Процедура ЯВыполняюПростойШагВГруппеОдин() Экспорт
КонецПроцедуры

//Когда я выполняю простой шаг в группе два
//@ЯВыполняюПростойШагВГруппеДва()
Процедура ЯВыполняюПростойШагВГруппеДва() Экспорт
КонецПроцедуры

//Когда я выполняю простой шаг в группе три
//@ЯВыполняюПростойШагВГруппеТри()
Процедура ЯВыполняюПростойШагВГруппеТри() Экспорт
КонецПроцедуры

//Когда я выполняю простой шаг в группе четыре
//@ЯВыполняюПростойШагВГруппеЧетыре()
Процедура ЯВыполняюПростойШагВГруппеЧетыре() Экспорт
КонецПроцедуры

&НаКлиенте
//Когда я выполняю простой шаг в группе пять
//@ЯВыполняюПростойШагВГруппеПять()
Процедура ЯВыполняюПростойШагВГруппеПять() Экспорт
КонецПроцедуры

&НаКлиенте
//Когда я выполняю простой шаг в группе шесть
//@ЯВыполняюПростойШагВГруппеШесть()
Процедура ЯВыполняюПростойШагВГруппеШесть() Экспорт
КонецПроцедуры
